// Line.cpp: CLine NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DD.h"
#include "main.h"
#include "Line.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern CITY	city[CITY_NUM];

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CLine::CLine()
{
	m_pLine = new LINE[MAX_LINE_NUM];
	memset( m_pLine, 0, sizeof(LINE)*MAX_LINE_NUM );
	m_pSmk = NULL;
}

CLine::~CLine()
{
	PDELETE(m_pLine);
}

int CLine::Add(int sx, int sy, int ex, int ey, int speed, int div )
{
	int ii;
	LINE* p = m_pLine;

	if( sy == ey )
		return -1;

	for( ii = 0; ii < MAX_LINE_NUM; ii ++, p++ )
	{
		//if( p->sy == 00 && p->ey == 0)
		if( p->speed == 00 )
		{
			p->sx = sx;
			p->sy = sy;
			p->ex = ex;
			p->ey = ey;
			p->speed = speed / 10 * 8;
			p->nowy =p->sy;
			p->stack=0;
			p->div = div;
			return ii;
		}	
	}
	return -1;


}

int CLine::AddFromXY( int sx, int sy, int speed, int div)
{
	// I_
	float citybase = RAND_MAX/CITY_NUM;
	int cityno = (int)(rand()/citybase);

	// ICBMZbg
	return Add( sx, sy, city[cityno].x+(CITY_CX/2), city[cityno].y, speed, div );
}

int CLine::AddAuto( int speed, int div )
{

	// _
	float icbmbase = RAND_MAX/SCRN_CX;
	int icbmx = (int)(rand()/icbmbase);

	// I_
	float citybase = RAND_MAX/CITY_NUM;
	int cityno = (int)(rand()/citybase);

	// ICBMZbg
	return Add( icbmx, 10, city[cityno].x+(CITY_CX/2), city[cityno].y, speed, div );
}

void CLine::Draw(CDC *pDC)
{
	int ii;
	LINE* p = m_pLine;
	for( ii = 0; ii < MAX_LINE_NUM; ii ++, p++ )
	{
		if( (p->sy != p->nowy) )//0div
		{
			pDC->MoveTo(p->sx,p->sy);
			pDC->LineTo(p->nowx,p->nowy);
		}
	}
}

void CLine::Go(int elp)
{
	int ii;
	LINE* p = m_pLine;

	for( ii = 0; ii < MAX_LINE_NUM; ii ++, p++ )
	{
		if(p->sy == p->ey)
			continue;
		
		/// x m
		float fDx;
		fDx = (float)(p->ex - p->sx)/(float)abs(p->ey - p->sy);
		p->nowx = p->sx + (int)(fDx*(float)abs(p->nowy - p->sy));

		/// y m
		p->stack+=elp;

		// ړʂ܂H
		if( p->stack >= p->speed )
		{
			// ̒eȉꍇj
			if( p->sy > p->ey )
			{
				(p->nowy)-=(p->stack/p->speed);
				p->stack=p->stack%p->speed;

				// V܂Ƃꍇ
				if( (p->ey > p->nowy) )
				{
					m_pSmk->Add(p->ex,p->ey);
					memset( p, 0,  sizeof(LINE) );
					continue;
				}

			}
			// G̒eiォ牺̏ꍇj
			else
			{
				if( p->speed < 1 )
					p->speed = 200; //ZeroDiv

				(p->nowy)+=(p->stack/p->speed);
				p->stack=p->stack%p->speed;

				// V܂Ƃꍇ //
				if( (p->ey < p->nowy) )
				{
					m_pSmk->Add(p->nowx,p->nowy);
					CDDApp* pApp = (CDDApp*)AfxGetApp();
					pApp->myPlaySound(IDR_SND_CITYEXP);
					memset(p, 0, sizeof(LINE));

					continue;
				}

				// Ăꍇ //
				int gen = m_pSmk->HitTest(p->nowx, p->nowy);	// ̐
				if(gen>0)
				{
					//int score = /*p->speed / 10 + */ gen*10;
					m_pMain->m_nCurrentScore += gen*2;
					m_pSmk->Add(p->nowx,p->nowy, gen*2);
					CDDApp* pApp = (CDDApp*)AfxGetApp();
					pApp->myPlaySound(IDR_SND_DON);
					memset( p, 0, sizeof(LINE) );
					continue;
				}

				//  //
				if( p->div > 1 )
				{
					float per = (float)((SCRN_CY/3*2)-(p->nowy));
					float base = RAND_MAX/per;

					if(	(per < 0)||					// E𒴂̂ŕ
						((int)(rand()/base) < 1 ))	// ɂ蕪
					{
						for( int divnum = 0; divnum < p->div; divnum++ )
							AddFromXY(p->nowx, p->nowy, p->speed, 0);
						memset( p, 0, sizeof(LINE) );
						continue;
					}
				}
			}
		}
	}
}


int CLine::GetCount()
{
	int ret = 0;
	int ii;
	LINE* p = m_pLine;

	for( ii = 0; ii < MAX_LINE_NUM; ii ++, p++ )
	{
		if( p->speed == 00 )
			continue;
		else
			ret++;
	}
	return ret;

}

/*
void CLine::SetSmoke(CSmoke *pSmk)
{
	//m_pSmk = pSmk;
}
*/

void CLine::Init(CMain *pMain)
{
	m_pMain = pMain;
	m_pSmk = &(pMain->m_smoke);
	memset( m_pLine, 0, sizeof(LINE)*MAX_LINE_NUM );
}
