// MainFrm.cpp : CMainFrame NX̓̒`s܂B
//

#include "stdafx.h"
#include "DD.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "game.h"

extern BOOL	gThreadEnd = FALSE;
extern BOOL gSuspended = FALSE;
extern BOOL gSoundOn   = FALSE;
extern DWORD gShowFliptime = TRUE;

extern UINT	gunWindowCX	= 320;
extern UINT	gunWindowCY	= 240;

extern UINT	gunRefleshRate = REFRESH_RATIO;


#define	MYWND_STYLE	WS_OVERLAPPED|WS_CAPTION|FWS_ADDTOTITLE|WS_SYSMENU|WS_MINIMIZEBOX


/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//ON_UPDATE_COMMAND_UI(ID_INDICATOR_TIME, OnUpdateTime)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_WM_CREATE()
	//ON_WM_MBUTTONDOWN()
	//ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_GAME_NEW, OnGameNew)
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_GAME_END, OnGameEnd)
	ON_COMMAND(ID_GAME_SUSPEND, OnGameSuspend)
	ON_UPDATE_COMMAND_UI(ID_GAME_SUSPEND, OnUpdateGameSuspend)
	ON_COMMAND(ID_GAME_SOUND, OnGameSound)
	ON_UPDATE_COMMAND_UI(ID_GAME_SOUND, OnUpdateGameSound)
	ON_COMMAND(ID_GAME_FLIPTIME, OnGameFliptime)
	ON_UPDATE_COMMAND_UI(ID_GAME_FLIPTIME, OnUpdateGameFliptime)
	ON_COMMAND(ID_GAME_F, OnGameF)
	ON_COMMAND(ID_GAME_B, OnGameB)
	ON_COMMAND(ID_NOSTRESS, OnNostress)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(ID_REF_10, ID_REF_200, OnRefleshRate)
	ON_UPDATE_COMMAND_UI_RANGE(ID_REF_10, ID_REF_200, OnUpdateRefleshRate)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

CMainFrame::CMainFrame()
{
	// TODO:
	m_pMDC = NULL;
	m_pMBMP = NULL;
	m_pApp = (CDDApp*)AfxGetApp();

}

CMainFrame::~CMainFrame()
{
	gThreadEnd = TRUE;

	m_pMDC->SelectObject(m_pOldpen);
	m_pMDC->SelectObject(m_pOldBMP);
	m_pMDC->DeleteDC();
	m_pMBMP->DeleteObject();

	PDELETE(m_pMDC);
	PDELETE(m_pMBMP);

}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;

	HCURSOR hCur = AfxGetApp()->LoadCursor(IDC_CUR_PLUS);
	HICON hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	cs.lpszClass = AfxRegisterWndClass(0,hCur,NULL,hIcon);

	// EBhȆ傫ݒ

	RECT rect;
	rect.top = rect.left = 0;
	rect.right = gunWindowCX;
	rect.bottom = gunWindowCY;

	cs.cx = 320;
	cs.cy = 240;
	cs.x = 0;
	cs.y = 0;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh


/**************************************************************************
*
*	`
*	OnPaint()
*
**************************************************************************/
void CMainFrame::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg

	CRect rc;
	GetClientRect(&rc);

	dc.StretchBlt(	0,0,gunWindowCX, gunWindowCY,m_pMDC,
					0,0,SCRN_CX,	SCRN_CY,SRCCOPY   );
}

/**************************************************************************
*
*	EBhE쐬̏
*	OnCreateClient()
*
**************************************************************************/
BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	// TODO:
	m_pMDC = new CDC;		// zDC̍쐬
	m_pMBMP = new CBitmap;	// zBitmap̍쐬

	CDC* pDC = this->GetDC();

	m_pMDC->CreateCompatibleDC(this->GetDC());
	m_pMBMP->CreateCompatibleBitmap(this->GetDC(),SCRN_CX,SCRN_CY);
	
	this->ReleaseDC(pDC);

	m_pOldBMP = m_pMDC->SelectObject(m_pMBMP);

	m_pMDC->FillSolidRect(0,0,SCRN_CX,SCRN_CY,RGB(0,0,0));

	// ItXN[̏
	m_pen.CreatePen(PS_SOLID,1,RGB(255,255,255));
	m_pOldpen = m_pMDC->SelectObject( &m_pen );

	m_game.InitDC( m_pMDC );
	
	return CFrameWnd::OnCreateClient(lpcs, pContext);
}

/**************************************************************************
*
*	wi`揈
*	OnEraseBkgnd()
*
**************************************************************************/
BOOL CMainFrame::OnEraseBkgnd(CDC* pDC) 
{
	// ǂ̓㏑̂łȂɂȂ
	return TRUE;
	//return CFrameWnd::OnEraseBkgnd(pDC);
}

/**************************************************************************
*
*	EBhEj
*	OnDestroy()
*
**************************************************************************/
void CMainFrame::OnDestroy() 
{
	gThreadEnd = TRUE;
	CFrameWnd::OnDestroy();
	DWORD dwExitCode;

	// XbhĂƕ`揈̂
	// EBhEjOɎ~߂
	do{
		::GetExitCodeThread( m_pApp->m_pGameThread, &dwExitCode );
	}while( dwExitCode == STILL_ACTIVE || gThreadEnd == TRUE );
}

/**************************************************************************
*
*	}EXNbN
*	OnLButtonDown
*
**************************************************************************/
void CMainFrame::OnLButtonDown(UINT nFlags, CPoint point) 
{
	RECT rc;
	this->GetClientRect(&rc);
	point.x = (point.x*SCRN_CX)/rc.right;
	point.y = (point.y*SCRN_CY)/rc.bottom;

	m_game.MouseButton( MOUSE_L, point );
	CFrameWnd::OnLButtonDown(nFlags, point);
}

/**************************************************************************
*
*	}EXNbN
*	OnMButtonDown
*
**************************************************************************/
/*
void CMainFrame::OnMButtonDown(UINT nFlags, CPoint point) 
{
	RECT rc;
	this->GetClientRect(&rc);
	point.x = (point.x*SCRN_CX)/rc.right;
	point.y = (point.y*SCRN_CY)/rc.bottom;

	m_game.MouseButton( MOUSE_M, point );
	CFrameWnd::OnMButtonDown(nFlags, point);
}
*/
/**************************************************************************
*
*	}EXNbN
*	OnRButtonDown
*
**************************************************************************/
/*
void CMainFrame::OnRButtonDown(UINT nFlags, CPoint point) 
{
	RECT rc;
	this->GetClientRect(&rc);
	point.x = (point.x*SCRN_CX)/rc.right;
	point.y = (point.y*SCRN_CY)/rc.bottom;

	m_game.MouseButton( MOUSE_R, point );
	CFrameWnd::OnRButtonDown(nFlags, point);
}
*/
/**************************************************************************
*
*	L[{[h
*	OnKeyDown
*
**************************************************************************/
void CMainFrame::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	POINT	point;
	GetCursorPos( &point );
	ScreenToClient( &point );
	RECT rc;
	this->GetClientRect(&rc);
	point.x = (point.x*SCRN_CX)/rc.right;
	point.y = (point.y*SCRN_CY)/rc.bottom;

	switch(nChar)
	{
	/*
	case 'Z':
	case 'z':
		m_game.MouseButton( MOUSE_L, point );
		break;
	case 'X':
	case 'x':
		m_game.MouseButton( MOUSE_M, point );
		break;
	case 'C':
	case 'c':
		m_game.MouseButton( MOUSE_R, point );
		break;
	*/
	case 'R':
	case 'r':
		if(gSuspended)
		{
			m_game.m_nStage = MODE_STAGE_DEMO1;
			gSuspended = FALSE;
		}
		break;
	
	case 'Q':
	case 'q':
		if(gSuspended)
			delete this;
		break;
	case 'S':
	case 's':
		gSoundOn = !gSoundOn;
		break;
	case ' ':
		gSuspended = !gSuspended;
		break;
	default:
		break;
	}
	CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

/**************************************************************************
*
*	j[FQ[VK쐬
*	OnGameNew
*
**************************************************************************/
void CMainFrame::OnGameNew() 
{
	m_game.m_nStage=MODE_STAGE_START;
}

/**************************************************************************
*
*	j[FQ[I
*	OnGameEnd
*
**************************************************************************/
void CMainFrame::OnGameEnd() 
{
	m_game.m_nStage=MODE_STAGE_OVER;
}

/**************************************************************************
*
*	j[FQ[TXyh
*	OnGameSuspend
*
**************************************************************************/
void CMainFrame::OnGameSuspend() 
{
	gSuspended = !gSuspended;
}

/**************************************************************************
*
*	j[XVFQ[TXyh
*	OnUpdateGameSuspend
*
**************************************************************************/
void CMainFrame::OnUpdateGameSuspend(CCmdUI* pCmdUI) 
{
	// TODO:
	if( gSuspended )
		pCmdUI->SetCheck( TRUE );
	else
		pCmdUI->SetCheck( FALSE );
}

/**************************************************************************
*
*	j[FTEh
*	OnGameSound
*
**************************************************************************/
void CMainFrame::OnGameSound() 
{
	gSoundOn = !gSoundOn;	
}

/**************************************************************************
*
*	j[XVFTEh
*	OnUpdateGameSound
*
**************************************************************************/
void CMainFrame::OnUpdateGameSound(CCmdUI* pCmdUI) 
{
	if( gSoundOn )
		pCmdUI->SetCheck( TRUE );
	else
		pCmdUI->SetCheck( FALSE );
}


/**************************************************************************
*
*	j[Ftbvԕ\
*	OnGameFliptime
*
**************************************************************************/
void CMainFrame::OnGameFliptime() 
{
	gShowFliptime = !gShowFliptime;
}

/**************************************************************************
*
*	j[XVFtbvԕ\
*	OnGameFliptime
*
**************************************************************************/
void CMainFrame::OnUpdateGameFliptime(CCmdUI* pCmdUI) 
{
	if( gShowFliptime )
		pCmdUI->SetCheck( TRUE );
	else
		pCmdUI->SetCheck( FALSE );	
}

/**************************************************************************
*
*	j[FtbVԐݒ
*	OnRefleshRate
*
**************************************************************************/
void CMainFrame::OnRefleshRate(UINT nID) 
{
	switch( nID )
	{
	case ID_REF_10:
		gunRefleshRate = 10;
		break;
	case ID_REF_20:
		gunRefleshRate = 20;
		break;
	case ID_REF_50:
		gunRefleshRate = 50;
		break;
	case ID_REF_100:
		gunRefleshRate = 100;
		break;
	case ID_REF_200:
		gunRefleshRate = 200;
		break;
	default:
		gunRefleshRate = 100;
	}

}

/**************************************************************************
*
*	j[XVFtbVԐݒ
*	OnRefleshRate
*
**************************************************************************/
void CMainFrame::OnUpdateRefleshRate(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(FALSE);
	switch(pCmdUI->m_nID)
	{
	case ID_REF_10:
		if(gunRefleshRate == 10)
		pCmdUI->SetCheck();
		break;
	case ID_REF_20:
		if(gunRefleshRate == 20)
		pCmdUI->SetCheck();
		break;
	case ID_REF_50:
		if(gunRefleshRate == 50)
		pCmdUI->SetCheck();
		break;
	case ID_REF_100:
		if(gunRefleshRate == 100)
		pCmdUI->SetCheck();
		break;
	case ID_REF_200:
		if(gunRefleshRate == 200)
		pCmdUI->SetCheck();
		break;
	default:
		break;
	}

}

void CMainFrame::OnGameF() 
{
	m_game.m_nStage=MODE_STAGE_INTER;
	m_game.m_nStageNo++;

	if( m_game.m_nStageNo >33 )
		m_game.m_nStageNo = 33;
		return;
}

void CMainFrame::OnGameB() 
{
	m_game.m_nStage=MODE_STAGE_INTER;
	m_game.m_nStageNo--;

	if( m_game.m_nStageNo < 1 )
		m_game.m_nStage = 1;
		return;
}

void CMainFrame::OnNostress() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_game.m_bNoStress = !m_game.m_bNoStress;
}
