// Smoke.cpp: CSmoke NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "dd.h"
#include "main.h"
#include "Smoke.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CSmoke::CSmoke()
{
	m_pSmk = new SMOKE[ MAX_SMOKE_NUM ];
	memset( m_pSmk, 0, sizeof(SMOKE)*MAX_SMOKE_NUM );
}

//////////////////////////////////////////////////////////////////////

CSmoke::~CSmoke()
{
	if( m_pSmk != NULL )
		delete m_pSmk;
	//PDELETE( m_pSmk );
}

//////////////////////////////////////////////////////////////////////

int CSmoke::Add( int x, int y, int gen, int speed )
{
	int ii;
	SMOKE* p = m_pSmk;

	for( ii = 0; ii < MAX_SMOKE_NUM; ii ++, p++ )
	{
		if( p->size == 0 )
		{
			p->x = x;
			p->y = y;
			p->size = 1;
			p->flate = 1;
			p->speed = speed;
			p->stack = 0;
			p->gen = gen;
			return ii;
		}	
	}
	return -1;
}

//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////

BOOL CSmoke::HitTest( int x, int y )
{
	int ii;
	int	dx, dy;
	int	dwDis;

	int score = 0;


	SMOKE* p = m_pSmk;

	// ʔ͈͊OȂΔ肵Ȃ
	if( (x<0 || x>SCRN_CX)||(y<0 || y>SCRN_CY) )
		return 0;

	for( ii = 0; ii < MAX_SMOKE_NUM; ii ++, p++ )
	{
		// TCYOȂ瓖蔻Ȃ
		if( p->size == 0 )
			continue;

		// 
		dx = p->x - x;
		dy = p->y - y;
		
		dwDis = ( dx*dx + dy*dy );
		if( (p->size*p->size) > dwDis )
		{
			return p->gen;
		}
		
	}
	return score;

}

//////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////

int	CSmoke::GetCount()
{
	int ret = 0;
	int ii;
	SMOKE* p = m_pSmk;

	for( ii = 0; ii < MAX_SMOKE_NUM; ii ++, p++ )
	{
		if( p->size == 0 )
			continue;
		else
			ret++;
	}
	return ret;
}

//////////////////////////////////////////////////////////////////////

void CSmoke::Go(int elp)
{
	SMOKE* p = m_pSmk;
	int ii;

	for( ii = 0; ii < MAX_SMOKE_NUM; ii ++, p++ )
	{
		if( p->size == 0 )
		{
			continue;
		}
		else
		{
			p->stack+=elp;

			if( p->stack>p->speed)
			{
				p->stack%=p->speed;

				if(p->size > CIRCLE_SIZE)
					p->flate = -1;

				(p->size)+=(p->flate);
			}
		}
	}
}

void CSmoke::Draw(CDC *pDC)
{
	SMOKE* p = m_pSmk;
	int ii;

	// ̕\
	for( ii = 0; ii < MAX_SMOKE_NUM; ii ++, p++ )
	{
		if( p->size == 0 )
			continue;
		else
		{
			pDC->Ellipse(
				(p->x-p->size),
				(p->y-p->size),
				(p->x+p->size),
				(p->y+p->size)
				);
		}
	}

	p = m_pSmk;

	// _̕\
	for( ii = 0; ii < MAX_SMOKE_NUM; ii ++, p++ )
	{
		if( p->size == 0 )
			continue;
		else
		{
			// オPȏŖcĂ鎞ɓ_\
			if( p->gen > 1 && p->flate > 0)
				m_pMain->PrintRawF(p->x-MOJISIZE_X,p->y, _T("%d0"), p->gen);
		}
	}
	
}

void CSmoke::Init(CMain *pMain)
{
	m_pMain = pMain;
	memset( m_pSmk, 0, sizeof(SMOKE)*MAX_SMOKE_NUM );

}
