// Smoke.h: CSmoke NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#include "game.h"

#if !defined(AFX_SMOKE_H__9277B813_47CE_11D3_B2BB_00000E5F4C40__INCLUDED_)
#define AFX_SMOKE_H__9277B813_47CE_11D3_B2BB_00000E5F4C40__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

typedef struct tagSMOKE
{
	int	x;
	int	y;
	int size;
	int	flate;	// 1 or -1
	int		speed;	// 
	int		stack;
	int	gen;

}	SMOKE;

class CMain;

class CSmoke  
{
public:
	void Init(CMain *pMain);
	CMain* m_pMain;
	void Draw( CDC* pDC );
	void Go( int elp = 0 );
	CSmoke();
	virtual ~CSmoke();

	int 	Add( int x, int y, int gen = 1, int speed = 300 );
	int		HitTest( int x, int y );
	int		GetCount();
	SMOKE*	m_pSmk;

	//// inline
	inline int 	Add( CPoint cp )
		{return Add(cp.x, cp.y);}
	inline int	HitTest( CPoint cp )
		{return HitTest( cp.x, cp.y );}

};

////////////////////////////////////////////////////////
#endif // !defined(AFX_SMOKE_H__9277B813_47CE_11D3_B2BB_00000E5F4C40__INCLUDED_)
