// StgData.cpp: CStgData NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DD.h"
#include "StgData.h"
#include "Main.h"
#include "ufo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern CITY	city[CITY_NUM];

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CStgData::CStgData()
{
	//---------------------------------------------------//
	// ϐ
	//---------------------------------------------------//
	memset( &m_StgDat, 0, sizeof(STGDATA)*MAX_LINE_NUM );
	m_pLine = NULL;
	m_pUfo = NULL;

	//---------------------------------------------------//
	// 
	//---------------------------------------------------//
	srand((unsigned int)GetTickCount());

	//---------------------------------------------------//
	// \[Xnh̎擾
	//---------------------------------------------------//
	HINSTANCE hInst = AfxGetResourceHandle();

	HRSRC hRes = FindResource( 
		hInst,						// resource-module handle 
		MAKEINTRESOURCE(IDR_STAGE),	// pointer to resource name 
		_T("STAGE")					// pointer to resource type
	); 

	HGLOBAL hStage = NULL;
	if (hRes != NULL)
		hStage = LoadResource(hInst, hRes);

	if(hStage != NULL )
		 m_hStageRes = LockResource(hStage);

}

CStgData::~CStgData()
{
}

BOOL CStgData::Go( int elp )
{
	//
	m_nStageTime += elp;
	
	// G̒eȂȂI
	if( m_pStgdataPointer->stage == 0xFF )
		return TRUE;

	// GICBM
	if((m_pStgdataPointer->time) * 1000U /*msec*/ < m_nStageTime)
	{
		// hbal
		if( m_pStgdataPointer->ID == 0 )
		{
			for( int ii = 0; ii < m_pStgdataPointer->number; ii++ )
			{
				m_pLine->AddAuto( m_pStgdataPointer->speed, m_pStgdataPointer->div );
			}
		}
		// ten
		else
		{
			m_pUfo->Add(m_pStgdataPointer->ID, m_pStgdataPointer->speed);
		}

		// Gf[^̃|C^i߂
		m_pStgdataPointer++;
	}
	return FALSE;

}

BOOL CStgData::ReadData(int stageno)
{
	stageno %= 33;	// 32ʂ܂`
		//BYTE	stage;		// stage
		//BYTE	ID;			// 00:ICBM 02:UFO
		//BYTE	time;		// (msec)
		//BYTE	speed;		// speed(/10)
		//BYTE	number;		// 
		//BYTE	div;		// 
		//BYTE	yobi3;
		//BYTE	yobi4;

	STGDATA* pSrc = (STGDATA*)m_hStageRes;
	STGDATA* pDest = &m_StgDat[0];

	//
	// Kvȃf[^Ƃ܂Ń|C^i߂
	//
	if( pSrc == NULL )
		return FALSE;

	while(pSrc->stage != stageno)
	{
		pSrc++;
	}

	//
	// Xe[Wf[^̓ǂݍ
	//
	for( int ii = 0; ii < MAX_LINE_NUM; ii++, pSrc++, pDest++ )
	{
		if( (pSrc->stage > stageno) )
		{
			pDest->stage = 0xFF; // ^[~l[V
			break;
		}

		// \[Xt@C̍Ō܂łPʖڂɖ߂
		// ͗\zO̓
		if( pSrc->stage == 0x00 )
		{
			// Zbg
			// ʃf[^oOĂ炱Ŗ[vEEE
			ii = 0;
			stageno = 1;
			pSrc = (STGDATA*)m_hStageRes;
			continue;
		}

		// ʃf[^ǂݍ
		memcpy( pDest, pSrc, sizeof(STGDATA) );
	}
	return TRUE;

}

void CStgData::InitStage(int stageno)
{
	m_nStageTime = 0;
	memset( &m_StgDat, 0, sizeof(STGDATA)*MAX_LINE_NUM );
	ReadData(stageno);
	m_pStgdataPointer = &m_StgDat[0];
}

void CStgData::Init(CMain* pMain)
{
	memset( &m_StgDat, 0, sizeof(STGDATA)*MAX_LINE_NUM );
	m_pLine = &(pMain->m_line);
	m_pUfo = &(pMain->m_ufo);
}


