// Ufo.cpp: CUfo NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DD.h"
#include "main.h"
#include "Ufo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

extern CDC*		pUfoDC;


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CUfo::CUfo()
{
	m_pUfo = new UFO[MAX_UFO_NUM];
	memset( m_pUfo, 0,  sizeof(LINE)*MAX_UFO_NUM );
	m_pSmk = NULL;

}

CUfo::~CUfo()
{
	PDELETE(m_pUfo);
}

void CUfo::Init(CMain *pMain)
{
	m_pMain = pMain;
	m_pSmk = &(pMain->m_smoke);
	memset( m_pUfo, 0,  sizeof(LINE)*MAX_UFO_NUM );
}

int CUfo::Add(int ufo, int speed)
{
	int ii;
	UFO* p = m_pUfo;

	/* 0 < ufoID < NUM_OF_UFO_CHAR */
	if( ufo > NUM_OF_UFO_CHAR+1 || ufo < 1 )
		ufo = 1;

	for( ii = 0; ii < MAX_UFO_NUM; ii ++, p++ )
	{
		if( p->speed == 0 )
		{
			p->sx = 0;
			p->sy = UFO_DEFAULT_HIGHT;
			p->ex = SCRN_CX;
			p->ey = UFO_DEFAULT_HIGHT;
			p->speed = speed/10;
			p->nowy =p->sy;
			p->stack=0;
			p->div = ufo;
			return ii;
		}	
	}
	return -1;
}

void CUfo::Draw(CDC *pDC)
{
	int ii;
	UFO* p = m_pUfo;

	for( ii = 0; ii < MAX_UFO_NUM; ii ++, p++ )
	{
		if( p->speed==0 )
			continue;
		int pic = (p->div-1) * (UFO_CX * 2) + (UFO_CX * (p->nowx%2));
		
		pDC->BitBlt(p->nowx,p->nowy,UFO_CX,UFO_CY,
			pUfoDC,pic, 0, SRCINVERT);
	}
}

void CUfo::Go(int elp)
{
	int ii;
	UFO* p = m_pUfo;

	for( ii = 0; ii < MAX_UFO_NUM; ii ++, p++ )
	{
		if(p->speed == 0)
			continue;
		
		/// x m
		p->stack+=elp;

		// ړʂ܂H
		if( p->stack >= p->speed )
		{
			// e𔭎˂邩H

			float base = RAND_MAX/SCRN_CX;
			if( (int)(rand()/base) < 20 )
				m_pMain->m_line.AddFromXY(p->nowx+(UFO_CX/2),p->nowy+UFO_CY+CIRCLE_SIZE);

			// 
			(p->nowx)+=(p->stack/p->speed);
			p->stack=p->stack%p->speed;

			// V܂Ƃꍇ
			// UFO͍Eֈړ
			if( (p->ex < p->nowx - UFO_CX) )
			{
				memset( p, 0, sizeof(LINE) );
				continue;
			}

			// Ăꍇ //
			int gen = m_pSmk->HitTest(
				p->nowx+(UFO_CX/2), p->nowy+(UFO_CY/2));	// ̐
			if(gen>0)
			{
				//int score = /*p->speed / 10 + */ gen*10;
				m_pMain->m_nCurrentScore += gen*100;
				m_pSmk->Add(
					p->nowx+(UFO_CX/2), p->nowy+(UFO_CY/2), gen*100);
				memset( p, 0, sizeof(LINE) );
				continue;
			}
		}
	}
}

int CUfo::GetCount()
{
	int ret = 0;
	int ii;
	UFO* p = m_pUfo;

	for( ii = 0; ii < MAX_UFO_NUM; ii ++, p++ )
	{
		if( p->speed == 0 )
			continue;
		else
			ret++;
	}
	return ret;
}
